#include <iostream>
#include <fstream>
#include "itemarray.hh"
#include "itemarrayinput.hh"
#include "itemarraycollection.hh"

int main(int argc, char *argv[]) {

  int minsupp=0;
  int maxsupp=0;
  char* infile=NULL;
  char* outfile=NULL;

  switch(argc) {
  case 5:
    minsupp=atoi(argv[1]);
    maxsupp=atoi(argv[2]);
    infile=argv[3];
    outfile=argv[4];
    break;
  case 4:
    outfile=argv[3];
  case 3:
    minsupp=atoi(argv[1]);
    infile=argv[2];
    break;
  default:
    cerr << "Usage: " << argv[0] 
	 << " minsupp infile [outfile]" << endl
	 << "or" << endl
	 << " minsupp maxsupp infile outfile" << endl;
    return -1;
  }


#ifdef IN_MEMORY
  ItemarrayMemoryInput in(infile,minsupp,maxsupp);
#else
  ItemarrayFileInput in(infile,minsupp,maxsupp);
#endif

  pair<Itemarray*,int>* is;
  
  ItemarrayMap imap;
  
  //  cerr << "0 0" << endl;

  for(int n=0; (is=in.getItemarray());) {
    imap.intersect(is);
    n+=is->second;
    delete is->first; delete is;
    if(minsupp>1 || maxsupp>0) imap.prune(in);
    //    cerr << n << " " << imap.size() << " " << imap.forbidden_size() << endl;
  }

  vector<int> counts(0);
  for(ItemarrayMap::const_iterator i=imap.begin(); i!=imap.end(); ++i) {
    if(counts.size()<=((*i).first)->n) counts.resize(((*i).first)->n+1);
    ++counts[((*i).first)->n];
  }

  for(int i=0; i<counts.size(); ++i)
    cout << counts[i] <<endl;


  if(outfile) {
    ofstream fout(outfile);
    fout << imap; 
    fout.close();
  }

  return 0;
}
